#include "usbtypes.h"
#include "usbapi.h"
#include "usbhw_lpc.h"

/** data storage area for standard requests */
static U8 abStdReqData[8];

/**
	USB reset handler
	
	@param [in] bDevStatus	Device status
 */
static void HandleUsbReset(U8 bDevStatus)
{
/*
	if (bDevStatus & DEV_STATUS_RESET) 
	{
		DBG("USB Reset command!!!\r\n");
	}
 */
}


/**
	Initialises the USB hardware and sets up the USB stack by
	installing default callbacks.
	
	@return TRUE if initialisation was successful
 */
BOOL USBInit(void)
{
	// init hardware
	USBHwInit();
	
	// register bus reset handler
	USBHwRegisterDevIntHandler(HandleUsbReset);
	
	// register control transfer handler on EP0
	USBHwRegisterEPIntHandler(0x00, USBHandleControlTransfer);
	USBHwRegisterEPIntHandler(0x80, USBHandleControlTransfer);
	
	// register standard request handler
	USBRegisterRequestHandler(REQTYPE_TYPE_STANDARD, USBHandleStandardRequest, abStdReqData);

	//   
	VICVectAddrTable[USB_INT_SLOT] = (unsigned long)USBHwISR;	
	VICVectCntlTable[USB_INT_SLOT] = 0x20 | USB_INT;
	VICIntEnable = 1 << USB_INT;

	//    USB
	USBDevIntEn = 0x0000000C;
	return TRUE;
}

